<?php
header('Content-Type: text/html; charset=utf-8');
use PFBC\Form;
use PFBC\Element;
use PFBC\View;
use PFBC\Validation;
use documongo\MongoObject\Document;
use documongo\MongoObject\DocumentType;

require_once('lib/fconnect.php');
$db = DBConnect::getInstance();
require_once('lib/frole.php');
$role = new Role();
$outhead = '';
$outbody = '';

function getPercent($db, $actual, $item, $accum, $chairtype, $parent){
	if($actual == 0){ return 0;	}
	$docs = $db->colDocs->find(array('type' => 'chair'));
	if($chairtype !== ''){ $docs = $db->colDocs->find(array('type' => 'chair', 'chairtype' => $chairtype)); }
	if($parent!==''){ $docs = $db->colDocs->find(array('type' => 'chair', 'parent' => $parent)); }
	foreach($docs as $doc){
		if(isset($doc['teachers'])){
			$teachers = count($doc['teachers']);
		}else{
			$teachers = 1;
		}
		$thisValue = 0;
		if($accum){
			if(isset($doc[$item])){
				$thisValue += (float)$doc[$item];
			}
		}else{
			if(isset($doc['versions'])){
				foreach($doc['versions'] as $version){
					if(isset($version['content'][$item])){
						$thisValue += (float)$version['content'][$item];
					}
				}
			$thisValue += (float)(isset($doc[$item]) ? $doc[$item] : 0);
			}
		}
		$array[] = $thisValue/$teachers;
	}
	$old_count = count($array);
	$array = array_diff($array, array(0));
	$count = count($array);
	if($count == 0){ return 0; }
	if($count == 1 && current($array) !== 0){ return 100; }
	if($count == 1 && current($array) == 0){ return 0; }
	if($count < $old_count){ $array[] = 0; }
	sort($array);
	$count = count($array);
	if($count % 2 !== 0){
		$medianIndex = floor($count/2);
		$medianValue = $array[$medianIndex];
	}else{
		$medianIndex = $count/2;
		$two = $array[$medianIndex];
		$one = $array[$medianIndex-1];
		$medianValue = ($one + $two) / 2;
	}
	if($actual == $medianValue){ return 50; }
	if($actual < $medianValue){
		$min = $array[0];
		$max = $medianValue;
		$delta = $max - $min;
		if($delta != 0){ return 50 * ($actual - $min) / $delta; }else{ return 0; }
	}
	if($actual > $medianValue){
		$min = $medianValue;
		$max = $array[$count - 1];
		$delta = $max - $min;
		if($delta != 0){ return 50 + 50 * ($actual - $min) / $delta; }else{ return 0;}
	}
	die('Ошибка приведения к 100');
}

if(isset($_GET['id'])){
	$j = 0;
	$k = 1;
	$key = 0;
	$periodcells = '';
	$table = '';
	$tableend = '';
	$thisSum = 0;
	$pretable = array();
	$pregraph = array();
	$graphAvg = array();
	$periodcells = '';
	$doc = $db->colDocs->findOne(array('_id'=>new \MongoId($_GET['id'])));
	$faculty = $db->colDocs->findOne(array( 'uuid' => $doc['parent']))['title_ru'];
	if(!isset($doc['chairtype'])){
		$doc['chairtype']=NULL;
	}
	switch($doc['chairtype']){
		case 'T':
			$thisProfile = 'спортивного и творческого';
		break;
		case 'G':
			$thisProfile = 'гуманитарного';
		break;
		case 'E':
			$thisProfile = 'естественнонаучного';
		break;
		case 'P':
			$thisProfile = 'педагогического';
		break;
	}
	if(isset($doc['versions'])){
		$cols = count($doc['versions']) + 1;
	}else{
		$cols = 0;
	}
	for($i=1;$i<=$cols;$i++){
		if($i<10) continue; //Так оставим периоды с 10 и дальше
		switch($i){
			case '10':
				$periodcells .= '
				<td><b>09.2016</b></td>
				';
			break;
			case '11':
				$periodcells .= '
				<td><b>12.2016</b></td>
				';
			break;
			case '10':
				$periodcells .= '
				<td><b>05.2017</b></td>
				';
			break;
		default:
		$periodcells .= '
				<td><b>05.2017</b></td>
				';
		}


	}
	$periodcells .= '<td><b>Итого</b></td>';
	$params = $db->colModel->findOne(
		array("name" => "chair")
	);
    $substring = '';
	foreach($params['items'] as $item){
		$row='';
		$key++;
		if($key % 2 == 1){
			$bg = ' style="background:#cccccc;"';
		}else{
			$bg = '';
		}
		if(isset($item['accumulative']) && $item['accumulative']){
			$accum = '<span style="color:red;">накоп</span>';
		}else{
			$accum = '';
		}
		if(isset($item['pdf']) && $item['pdf']){
			if($item['type'] == 'section'){
				$pretable[] = $table.$tableend.'
					<h3 style="page-break-before: always;">Раздел '.++$j.'. '.$item['label_ru'].'</h3>
						<table>';
				$row = '<tr'.$bg.'>
					<td class="left">'.$item['index_code_ru'].'</td>
					<td class="left"><b>Показатели раздела '.$j.': '.$item['label_ru'].'.</b></td>
					'.$periodcells.'
					</tr>';
				$table = '';
				if(isset($graphPar)){$graphTitles[] = implode(', ', $graphPar); $graphPar = array();}
				if(isset($graphVal)){$graphValues[] = implode (', ',$graphVal); $graphVal = array();}
				if(isset($graphValPro)){ $graphValuesPro[] = implode (', ', $graphValPro); $graphValPro = array(); }
				if(isset($graphValFAC)){ $graphValuesFAC[] = implode (', ', $graphValFAC); $graphValFAC = array(); }

			}elseif($item['type'] == 'subsection'){
					$substring = $item['label_ru'];
			}
			else{
				if($tableend == ''){
					$tableend = '</table><hr>
							<p>&nbsp;</p>
							<p>&nbsp;</p>';
				}
				$cells = '';
				if(isset($item['accumulative'])){
					for($i=0; $i<=$cols-2; $i++){
						if($i<9) continue;
						$cell = '<td>'.@$doc['versions'][$i]['content'][$item['name']].'</td>';
						if(isset($item['accumulative']) && !$item['accumulative']){
							$thisSum += (FLOAT)$doc['versions'][$i]['content'][$item['name']];
						}
						$cells .= $cell;

					}
					if($item['accumulative']){
						$val = (FLOAT)@$doc[$item['name']];
					}else{
							$thisSum += @(FLOAT)$doc[$item['name']];
							$val = $thisSum;
							$thisSum = 0;
					}
					if(isset($doc['teachers'])){
						$actual = $val/count($doc['teachers']);
					}else{
						$actual = $val;
					}
				}
				if($item['type']!='subsection'){
		$graphVal[] = round(getPercent($db,$actual,$item['name'],$item['accumulative'],'',''),2);
		$graphValPro[] = round(getPercent($db,$actual,$item['name'],$item['accumulative'], @$doc['chairtype'],''),2);
		$graphValFAC[] = round(getPercent($db,$actual,$item['name'],$item['accumulative'], '',@$doc['parent']),2);
				}
					$cells .= '<td>'.@$doc[$item['name']].'</td><td>'.@$val.'</td>';
					$row = '<tr'.$bg.'>
<td class="left">'.$item['index_code_ru'].'</td>
<td class="left">'.$substring.' '.$item['label_ru'].' '.$accum.' </td>
'.$cells.'
</tr>';
					$graphPar[] = "'".$item['index_code_ru']."'";
				}
				$table .= $row;
			}
		}
        $pretable[] = $table.$tableend;
		if(isset($graphPar))	{ $graphTitles[] = implode (', ', $graphPar); 		$graphPar = array(); }
        if(isset($graphVal))	{ $graphValues[] = implode (', ', $graphVal); 		$graphVal = array(); }
        if(isset($graphValPro))	{ $graphValuesPro[] = implode (', ', $graphValPro); $graphValPro = array(); }
        if(isset($graphValPro))	{ $graphValuesFAC[] = implode (', ', $graphValFAC); $graphValFAC = array(); }
}else{
	$outbody = 'Необходимо выбрать кафедру';
}
$pretable[] = '</table>';

foreach($pretable as $key => $value){
	if(isset($graphTitles[$key]))	{	$pregraphTitles[$key]	= $graphTitles[$key];	}
	if(isset($graphAverage[$key]))	{	$pregraphAvg[$key]		= $graphAverage[$key];	}
	if(isset($graphValues[$key]))	{	$pregraphVUZ[$key]		= $graphValues[$key];	}
	if(isset($graphValuesPro[$key])){	$pregraphPro[$key]		= $graphValuesPro[$key];}
	if(isset($graphValuesFAC[$key])){	$pregraphFAC[$key]		= $graphValuesFAC[$key];}
	$outbody .= $value;
	if(isset($pregraphTitles[$key]) && isset($pregraphVUZ[$key])){
		$avgs = explode(', ',$pregraphVUZ[$key]);
		foreach($avgs as $avg){
			$graphAvg[] = 50;
			}
		$pregraphAvg[$key] = implode(', ',$graphAvg);
		$graphAvg = array();
		$colspan = $cols + 3;
		$outbody .= '
	<tr><td colspan = "'.$colspan.'">
	<table style="border:none;max-width: 600px;margin:0 auto;">
	<tr>
	<td class="rating">
	</td>
	<td style="border:none;">
	<div id="graph_'.$key.'_1" style="min-width: 350px; max-width: 420px; height: 400px; margin: 0 auto"></div>
	</td>
	<td style="border:none;">
	<div id="graph_'.$key.'_2" style="min-width: 350px; max-width: 420px; height: 400px; margin: 0 auto"></div>
	</td>
	<td style="border:none;">
	<div id="graph_'.$key.'_3" style="min-width: 350px; max-width: 420px; height: 400px; margin: 0 auto"></div>
	</td>
	<td class="rating">
	</td>
	</tr>
	</table>
	</td></tr>
		';
		$outhead .= "
		  <script type=\"text/javascript\">
$(function () {
    $('#graph_".$key."_1').highcharts({
    exporting:{
      enabled: false
    },
	credits: {
      enabled: false
	},
        chart: {
            polar: true,
            type: 'line'
        },
        title: {
            text: '".$doc['title_ru']." в сравнении со всеми кафедрами РГПУ им. А.И. Герцена.',
            x: 0
        },
        pane: {
            size: '60%'
        },
        xAxis: {
            categories: [".$pregraphTitles[$key]."],
            tickmarkPlacement: 'off',
            lineWidth: 0
        },
        yAxis: {
            gridLineInterpolation: 'polygon',
            lineWidth: 0,
            min: 0,
            max:100
        },
        tooltip: {
            shared: true,
            pointFormat: '<span style=\"color:{series.color}\">{series.name}: <b> {point.y:,.1f} %</b><br/>'
        },
        legend: {
            align: 'right',
            verticalAlign: 'bottom',
            y: -70,
            layout: 'vertical'
        },
        series: [{
            name: 'Медиана',
            data: [".$pregraphAvg[$key]."],
            pointPlacement: 'on'
        }, {
            name: 'Кафедра',
            data: [".$pregraphVUZ[$key]."],
            pointPlacement: 'on'
        }]
    });
});
</script>
<script type=\"text/javascript\">
$(function () {
    $('#graph_".$key."_2').highcharts({
    exporting:{
      enabled: false
    },
	credits: {
	enabled: false
	  },
     chart: {
         polar: true,
            type: 'line'
        },
        title: {
            text: '".$doc['title_ru']." среди кафедр ".@$thisProfile." профиля  РГПУ им. А.И. Герцена.',
            x: 0
        },
        pane: {
            size: '60%'
        },
        xAxis: {
            categories: [".$pregraphTitles[$key]."],
            tickmarkPlacement: 'off',
            lineWidth: 0
        },
        yAxis: {
            gridLineInterpolation: 'polygon',
            lineWidth: 0,
            min: 0,
            max:100
        },
        tooltip: {
            shared: true,
            pointFormat: '<span style=\"color:{series.color}\">{series.name}: <b> {point.y:,.1f} %</b><br/>'
        },
        legend: {
            align: 'right',
            verticalAlign: 'bottom',
            y: -70,
            layout: 'vertical'
        },
        series: [{
            name: 'Медиана',
            data: [".$pregraphAvg[$key]."],
            pointPlacement: 'on'
        }, {
            name: 'Кафедра',
            data: [".$pregraphPro[$key]."],
            pointPlacement: 'on'
        }]
    });
});
</script>

<script type=\"text/javascript\">
$(function () {
    $('#graph_".$key."_3').highcharts({
    exporting:{
      enabled: false
    },
 credits: {
      enabled: false
  },
        chart: {
            polar: true,
            type: 'line'
        },
        title: {
            text: '".$doc['title_ru']." среди структурного учебного подразделения (".$faculty.") ',
            x: -10
        },
        pane: {
            size: '60%'
        },
        xAxis: {
            categories: [".$pregraphTitles[$key]."],
            tickmarkPlacement: 'off',
            lineWidth: 0
        },
        yAxis: {
            gridLineInterpolation: 'polygon',
            lineWidth: 0,
            min: 0,
            max:100
        },
        tooltip: {
            shared: true,
            pointFormat: '<span style=\"color:{series.color}\">{series.name}: <b> {point.y:,.1f} %</b><br/>'
        },
        legend: {
            align: 'right',
            verticalAlign: 'bottom',
            y: -70,
            layout: 'vertical'
        },
        series: [{
            name: 'Медиана',
            data: [".$pregraphAvg[$key]."],
            pointPlacement: 'on'
        }, {
            name: 'Кафедра',
            data: [".$pregraphFAC[$key]."],
            pointPlacement: 'on'
        }]

    });
});
</script>
		";
    }
}
?><!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Информационно-аналитические материалы</title>
<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>
<script src="/js/bootstrap.min.js"></script>
<script src="//code.highcharts.com/highcharts.js"></script>
<script src="//code.highcharts.com/highcharts-more.js"></script>
<script src="//code.highcharts.com/modules/exporting.js"></script>
<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<link rel="stylesheet" href="/css/jquery-ui.css" />
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />
<link rel="stylesheet" href="/css/complexinfo.css" />
  <script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";
  </script>
<?=$outhead?>
</head>
<body>
<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings" style="text-align: left;">
    <h1 class="header__headings__heading">
      Информационно-аналитические материалы
    </h1>
    <h2 class="header__headings__subheading">
        По показателям комплексного рейтинга кафедр РГПУ им. А.И. Герцена
    </h2>
  </div>
  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>
  <div class="header__helper"></div>
</header>
<div class = "left">
	<?php
echo $role->userMenu($user->uuid);
//var_dump($user->uuid);
	?>

</div>

<!-- CURRENT PAGE -->

<div class="all">
<h3>Информационно-аналитические материалы по показателям мониторинга и комплексного рейтинга кафедр РГПУ им. А.И. Герцена.</h3>
<?php
	$this->renderNavigation();
	$actual = 0;
	if(isset($doc['title_ru'])){
		$uid = $user->uuid;
		$chair = $doc['title_ru'];
		$date = date("Y-m-d H:i:s");
		 if($uid=="4cb40ad3-e50c-46e6-bdc0-ed2ccc84ded6" ||
			$uid=="049cbbfb-bd10-4552-8657-104fd5a6f970" ||
			$uid=="aa68eab7-04dd-40fa-bd7e-b949de044a76" ||
			$uid=="4ba6401f-39d7-4311-9d54-78730c8c33d4" ||
			$uid=="b2ecc4ff-c31f-4eab-bdea-5062ea0fd9c3" ||
			$uid=="810f48da-f152-4042-bed1-71c400ce7c45" ||
			$uid=="07f3723c-c4c6-456a-a3e0-622ece49dc97" ||
			$uid=="9b4c61b4-59a0-47a8-b04e-6aa0d5592ce4" ||
			$uid=="4952f86d-f585-47a5-9dfc-ecc7164dfea2" ||
			$uid=="26261dbc-903f-40b9-9497-72fff73b1351"){
			$visit = $db->colVisit->findOne(array('uid'=>$uid));
			if(!isset($visit)){
				$db->colVisit->insert(
				array('uid'=>$uid)
				);
				$db->colVisit->update(
				array('uid' => $uid), array('$push' =>
				array($date => $chair)));
			}else{
				$db->colVisit->update(
				array('uid' => $uid), array('$push' =>
				array($date => $chair))
				);
			}
		}
		echo '<h1>'.$doc['title_ru'].'.</h1>';
		echo '<h2>Общая информация</h2>';
		echo '<table class="general">';
		if(isset($doc['parent'])){$fak = $db->colDocs->findOne(array('uuid'=>$doc['parent']));}
		echo '<tr><td style="width:250px;">Структурное учебное подразделение:</td><td>'.$fak['title_ru'].'</td></tr>';
		echo '<tr><td>Кафедра:</td><td>'.$doc['title_ru'].'</td></tr>';
		if(isset($doc['chairtype'])){
			switch($doc['chairtype']){
				case 'G': $profil = 'Гуманитарный'; break;
				case 'T': $profil = 'Творческий или спортивный'; break;
				case 'E': $profil = 'Естественнонаучный'; break;
                default: $profil = 'НЕ УКАЗАН';
			}
			}else{$profil = 'НЕ УКАЗАН';}
		echo '<tr><td>Профиль кафедры:</td><td>'.$profil.'</td></tr>';
		$teachers['st'] 	= 0;
		$teachers['all'] 	= count(@$doc['teachers']);
		$teachers['list'] 	= '';
		if(isset($doc['teachers'])){
			foreach($doc['teachers'] as $teacher){
				$teachers['list'] .= '<li>'.$teacher['name'].' <i>'.$teacher['rate'].' ст.</i></li>';
				$teachers['st'] += $teacher['rate'];
			}
		}else{$teachers['list'] = 'Ни одного преподавателя не указано';}
		/*echo '<tr><td>Cтавок:</td><td>'.$teachers['st'].'</td></tr>';
		echo '<tr><td>Преподаватели:</td><td><ul>'.$teachers['list'].'</ul>
		<a href="/mail/form.php" target="_blank" onclick="window.open(\'/mail/form.php?chair='.$doc['title_ru'].'\',\'Задать вопрос\',\'resizable=yes,width=550,height=350,left=500,top=\'+(screen.availHeight/2-365)+\'\');return false;">
		<button name="error">Сообщить об ошибке.</button></a></td></tr>';
		echo '<tr><td>Всего:</td><td>'.$teachers['all'].' сотрудников</td></tr>';*/
		echo '</table>';
	}
echo '<h2>Абсолютные значения показателей за период с 20 сентября по 19 декабря 2017 года.</h2>';
echo $outbody;
?>
</div>
</body>
</html>
